'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _flexboxReact = require('flexbox-react');

var _flexboxReact2 = _interopRequireDefault(_flexboxReact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var alertIconUri = require('../../assets/alert-icon.svg');
var warningIconUri = require('../../assets/warning-yellow.svg');
var MicroCardContentStatus = function MicroCardContentStatus(props) {
  var icon = '';

  switch (props.status) {
    case 'critical':
      icon = alertIconUri;
      break;
    case 'warning':
      icon = warningIconUri;
      break;
    default:
      icon = '';
  }

  return _react2['default'].createElement(
    _flexboxReact2['default'],
    { marginRight: '5px' },
    _react2['default'].createElement('img', { className: 'microcard__stateIcon', src: icon, alt: 'icon' })
  );
};

MicroCardContentStatus.defaultProps = {
  status: 'critical'
};

MicroCardContentStatus.propTypes = {
  status: _react2['default'].PropTypes.string
};

exports['default'] = MicroCardContentStatus;
module.exports = exports['default'];
//# sourceMappingURL=MicroCardContentStatus.js.map