'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var d3 = (0, _assign2['default'])({}, require('d3-selection'), require('d3-array'));

var ChartOverlay = function (_React$Component) {
  (0, _inherits3['default'])(ChartOverlay, _React$Component);

  function ChartOverlay(props) {
    (0, _classCallCheck3['default'])(this, ChartOverlay);

    var _this = (0, _possibleConstructorReturn3['default'])(this, _React$Component.call(this, props));

    _this.mouseMove = _this.mouseMove.bind(_this);
    return _this;
  }

  ChartOverlay.prototype.mouseMove = function mouseMove(e) {
    var _props = this.props,
        xScale = _props.xScale,
        data = _props.data;

    var bisectXAxis = d3.bisector(function (d) {
      return d.x;
    }).left;
    var node = _reactDom2['default'].findDOMNode(this);

    var bounds = node.getBoundingClientRect();
    var x = Math.floor(Math.abs(e.clientX - bounds.left));
    var y = Math.floor(Math.abs(e.clientY - bounds.top));

    var x0 = xScale.invert(x);

    var i = bisectXAxis(data, x0, 1);
    var d0 = this.props.data[i - 1];
    var d1 = this.props.data[i];
    var d = x0 - d0.x > d1.x - x0 ? d1 : d0;

    // const toolTipData = {
    //   key: d[this.props.xData],
    //   value: d[yData],
    // };

    var toolTipPos = { x: x, y: y };

    this.props.mouseMove(d, toolTipPos);
  };

  ChartOverlay.prototype.render = function render() {
    var _this2 = this;

    var _props2 = this.props,
        height = _props2.height,
        hideToolTip = _props2.hideToolTip,
        width = _props2.width;

    return _react2['default'].createElement('rect', {
      className: 'overlay',
      width: width,
      fill: 'none',
      stroke: 'none',
      style: { pointerEvents: 'all' },
      height: height,
      onMouseMove: function onMouseMove(e) {
        _this2.mouseMove(e);
      },
      onMouseOut: hideToolTip
    });
  };

  return ChartOverlay;
}(_react2['default'].Component);

ChartOverlay.propTypes = {
  height: _react.PropTypes.number.isRequired,
  width: _react.PropTypes.number.isRequired,
  hideToolTip: _react.PropTypes.func,
  mouseMove: _react.PropTypes.func.isRequired,
  xScale: _react.PropTypes.func.isRequired,
  yScale: _react.PropTypes.func.isRequired,
  data: _react.PropTypes.array.isRequired
};

exports['default'] = ChartOverlay;
module.exports = exports['default'];
//# sourceMappingURL=ChartOverlay.js.map